<?php
/**
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * No redistribute in other sites, or copy.
 *
 * @author    Help2Presta <demo@demo.com>
 * @copyright 2007-2015 Help2Presta
 * @license   http://localhost
 */

ini_set('allow_url_fopen', true);

class Employeealert extends Module
{
	private $_html = '';
	private $_postErrors = array();

	public function __construct()
	{
		$this->name = 'employeealert';
		if (_PS_VERSION_ < '1.4.0.0')
			$this->tab = 'Home';
		if (_PS_VERSION_ > '1.4.0.0' && _PS_VERSION_ < '1.5.0.0')
		{
			$this->tab           = 'front_office_features';
			$this->author        = 'RSI';
			$this->need_instance = 0;
		}
		if (_PS_VERSION_ > '1.5.0.0')
		{
			$this->tab    = 'front_office_features';
			$this->author = 'Help2Presta';
		}
        if (_PS_VERSION_ > '1.6.0.0') {
            $this->bootstrap = true;
        }

		$this->version = '1.1.0';

		parent::__construct();

		$this->displayName = $this->l('Employee Alert');
		$this->description = $this->l('Alert when add, change or modify a employee');
		if (_PS_VERSION_ < '1.5')
			require(_PS_MODULE_DIR_.$this->name.'/backward_compatibility/backward.php');

	}
    public function uninstall()
    {
        if (!parent::uninstall()) {
            return false;
        }
		
			Db::getInstance()->Execute('DROP TRIGGER IF EXISTS `alert`');

        return true;
    }
	public function install()
	{
		if (!parent::install())
			return false;
		 if (!Configuration::updateValue(
            'EMPLOYEE_MAIL',
            'demo@prestashop.com'
        )
        )
		{
            return false;
        }
	Db::getInstance()->Execute('CREATE TABLE IF NOT EXISTS '._DB_PREFIX_.'alerte (`lastname` varchar(255) NULL, `email` varchar(255) NULL) ENGINE=MyISAM default CHARSET=utf8;');
	Db::getInstance()->Execute('
	CREATE TRIGGER `alert`
    BEFORE  UPDATE ON '._DB_PREFIX_.'employee
    FOR EACH ROW
	IF NEW.passwd <> OLD.passwd THEN
    INSERT INTO '._DB_PREFIX_.'alerte VALUES(NEW.lastname, NEW.email);
	END IF;');
   
	
/*	    Db::getInstance()->Execute('
	CREATE TRIGGER `alert`
    AFTER INSERT ON '._DB_PREFIX_.'employee
    FOR EACH ROW
    INSERT INTO '._DB_PREFIX_.'alerte VALUES(NEW.lastname, NEW.email);');*/
		return true;
	}

public function getContent()
	{
		$output = '<h2>'.$this->displayName.'</h2>';
		if (_PS_VERSION_ < '1.5.0.0')
		{
		if (Tools::isSubmit('submitTwitstate'))
		{
			$twitstateuser = Tools::getValue('mail');
			
				Configuration::updateValue('EMPLOYEE_MAIL', $mail);

				$output .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />'.$this->l('Settings updated').'</div>';
			
		}

		return $output.$this->displayForm();
		}
		else
			return $this->_displayInfo().$this->postProcess().$this->renderForm();
	}
	   private function _displayInfo()
    {
      
	   
	   $this->context->smarty->assign('cronurl', _PS_BASE_URL_._MODULE_DIR_.'employeealert/employeealert-cronalert.php?token='.Tools::substr(Tools::encrypt('employeealert/cronalert'), 0, 10).'&id_shop='.$this->context->shop->id);
        return $this->display(
            __FILE__,
            'views/templates/hook/infos.tpl'
        );
    }
    public function cronalert()
	{
    $sql = Db::getInstance()->ExecuteS('SELECT * FROM '._DB_PREFIX_.'alerte;');
	if ($sql != null)
	{
		foreach($sql as $val)
		{
		$msg = $this->l('The user: ').$val['lastname'].' '.$val['email'].' '.$this->l('has changed the data in their account.').'\n';
		}
	    mail(Configuration::get('EMPLOYEE_MAIL'),$this->l('Alert from your STORE'),$msg);
		
	}
    $sql2 = Db::getInstance()->Execute('TRUNCATE TABLE '._DB_PREFIX_.'alerte;');

	die();
	
	
	
	}
	public function postProcess()
	{
		$errors = '';
		$output = '';
		if (Tools::isSubmit('submitTwitstate'))
		{


			if ($mail = Tools::getValue('mail'))
				Configuration::updateValue('EMPLOYEE_MAIL', $mail);
			elseif (Shop::getContext() == Shop::CONTEXT_SHOP || Shop::getContext() == Shop::CONTEXT_GROUP)
				Configuration::deleteFromContext('EMPLOYEE_MAIL');



			$output .= $this->displayConfirmation($this->l('Settings updated.').'<br/>');

			//if (!$errors)
			return $output;

		}
	}

	public function getConfigFieldsValues()
	{
		$fields_values = array(
			'mail' => Tools::getValue('mail', Configuration::get('EMPLOYEE_MAIL')),
			
		);
		return $fields_values;
	}

	public function renderForm()
	{
		$this->postProcess();
		$fields_form                      = array(
			'form' => array(
				'legend'      => array(
					'title' => $this->l('Configuration'),
					'icon'  => 'icon-cogs'
				),
				
				'description' => $this->l('Put your email to get notifications when a employee change something in the acount'),
				'input'       => array(
					array(
						'type'  => 'text',
						'label' => $this->l('Email'),
						'name'  => 'mail',
						'desc'  => $this->l('Your email'),
					
					),
					
				),
				'submit'      => array(
					'title' => $this->l('Save'),
				)

			),
		);
		$helper                           = new HelperForm();
		$helper->show_toolbar             = true;
		$helper->table                    = $this->table;
		$lang                             = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language    = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$this->fields_form                = array();
		$helper->identifier               = $this->identifier;
		$helper->submit_action            = 'submitTwitstate';
		$helper->currentIndex             = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;

		$helper->token    = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages'    => $this->context->controller->getLanguages(),
			'id_language'  => $this->context->language->id
		);
		return $helper->generateForm(array($fields_form));
	}

}

?>